// Aner Ben-Artzi - Efficient Coherence-Based Visibility Sampling (CBVS) of Environment Maps
// Columbia University 2004
//
// Container.h: interface for the Container class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CONTAINER_H__56E2D897_938B_4A47_8643_BC1798A1AEE6__INCLUDED_)
#define AFX_CONTAINER_H__56E2D897_938B_4A47_8643_BC1798A1AEE6__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "vv_header.h"

#ifndef RAYTRACER
class Area;
#endif //RAYTRACER


class VVTrace;

class Container  
{
public:
	static void direction2xy(int& x, int& y, Point3d direction, int size);
	static bool xy2direction(Point3d& result, int x, int y, int size);
	static void unprojectStretch(Point3d& result, double x, double y);
	static void projectStretch(Point3d& result, Point3d direction);
	static float maxf(float a, float b);
	static int intlog2(int num);

	static bool useGlut;
	static int oldx;
	static int oldy;
	static bool keys[255];
	static int keysdown;
	static char previousRecord[40];
	static FILE* recordFile;
	static bool record;
	static int draggedx;
	static int draggedy;
	static bool dragAllLights;
	static bool passiveParent;
	static bool leftDown;
	static int glutWidth;
	static int glutHeight;
	static int numberOfLights;
	static int size;
	static Point3d cameraLocation;
	static Point3d cameraLookAt;
	static bool trackMouse;
	static Depth_Normal** Image_Info;
	static int activeArea;
	static Light_Graph** graph;
	static Light* thelights;
	static bool* horizons;
	static int draggedArea;
	static int** lightID;
	static char** used;
	static int lightSize;
	static Point3d objectColor[20];
	static int strongestSources[20];

#ifndef RAYTRACER
	static bool sameTrace(VVTrace* one, VVTrace* other);
	static VVTrace* theOneTrueTrace;
	static Area* areas[6];
#endif //RAYTRACER

public:
	static void rotatelights(float degrees);
	static void project(int& x, int& y, Point3d location);
	Container();
	virtual ~Container();
	static void readData(char* filebase);
	static int findArea(int glutx, int gluty);
	static int findLight(int areax, int areay);
	static void init();
	static int findNearestLight(Point3d direction, bool scoot);

#ifndef RAYTRACER

	static void setTrace(int theArea, VVTrace* newValue);
	static void produceDiff(Area* intoArea, Area* area1, Area* area2);
	static void dragFromTo(int fromAreaNum, int toAreaNum);

	static void display();
	static void passiveMotion(int x, int y);
	static void reshape(int w, int h);
	static void keyup(unsigned char key, int x, int y);
	static void keyboard(unsigned char key, int x, int y);
	static void special(int key, int x, int y);
	static void mouse(int button, int state, int x, int y);
	static void motion(int x, int y);
	static void menu(int entry);
	static void findGlutXY(int& glutx, int& gluy, int area, int areax, int areay);

protected:
	static void readInstructions(char* file);

#endif //RAYTRACER

};

#define Image_Info Container::Image_Info
#define thelights Container::thelights
#define graph Container::graph

#endif // !defined(AFX_CONTAINER_H__56E2D897_938B_4A47_8643_BC1798A1AEE6__INCLUDED_)
